--[[ darksky.lua for [ domoticzVents >= 2.4 ]
    
author/auteur = papoo -> update par Lolo
update/mise à jour = 18/07/2019
creation = 15/09/2018
https://pon.fr/dzvents-darksky-et-probabilite-de-pluie/
https://github.com/papo-o/domoticz_scripts/blob/master/dzVents/scripts/darksky.lua
https://www.domoticz.com/forum/viewtopic.php?f=59&t=24928
https://easydomoticz.com/forum/viewtopic.php?f=17&t=7136&p=58822#p58822
This script requires prior registration to the DarkSky API
Ce script nécessite l'inscription préalable à l'API DarkSky
Enter the URL and request a free API key
Entrez l'URL et demandez une clé API gratuite
https://darksky.net/dev
place this DZvents script in /domoticz/scripts/dzVents/scripts/ directory
script dzvents à placer dans le répertoire /domoticz/scripts/dzVents/scripts/
--]]               

--[[
    Add, modify or delete variables proba_pluie_h [] by changing the number (hour) between []
    the name "in quotation marks" or the idx without quotes (avoid accents) of the device of percentage of rain at [x] associated time, nil if not used
	This script can potentially retrieve the 48 available time forecasts. Create as many percent virtual sensors as you would expect from the hourly forecasts.
    for my part, I only get the forecasts at 1 hour, 2 hours, 4 hours, 6 hours, 12 hours and 24 hours.
    Only 48 possible forecasts
    Ajoutez, modifiez ou supprimez les variables proba_pluie_h[] en changeant le nombre (heure) entre []
    renseigner ensuite le nom "entre guillemets" ou l'idx sans guillemets (évitez les accents) du device pourcentage probabilité pluie à [x] heure associé, nil si non utilisé
    Ce script peut potentiellement récupérer les 48 prévisions horaires disponible. Créez autant de capteurs virtuels pourcentage correspondant aux prévisions horaires que vous souhaitez.
    pour ma part, je ne récupère que les prévisions à 1 heure, 2 heures, 4 heures, 6 heures, 12 heures et 24 heures.
    Seulement 48 prévisions possible
]]--
local proba_pluie_h = {}
proba_pluie_h[1]= "Proba Pluie 1h"		--296     			
proba_pluie_h[2]= "Proba Pluie 2h"		--297    			 
proba_pluie_h[3]= nil    			            
proba_pluie_h[4]= "Proba Pluie 4h"		--298    			
proba_pluie_h[5]= nil    			            
proba_pluie_h[6]= "Proba Pluie 6h"   	--335
proba_pluie_h[8]= nil   			
proba_pluie_h[12]= "Proba Pluie 12h"	--299    		
proba_pluie_h[24]= "Proba Pluie 24h"	--300   			
proba_pluie_h[36]= nil   			            
proba_pluie_h[48]= nil


-- Devices to update with API result
local dev_temp_hum_baro = 290 		-- or nil /  dummy receive Temp+Hum+Baro / Type Temp + Humidity + Baro
local dev_temperature = nil 		-- or nil /  dummy receive temperature / Type Temp
local dev_rain = 288 				-- or nil /  dummy receive rain in mm / Type Rain
local dev_rainExp = 293 			-- or nil /  dummy receive rain in mm / Type Rain
local dev_humidity = nil 			-- or nil /  dummy receive humidity / Type Humidity
local dev_barometer = nil 			-- or nil /  dummy receive pressure / SubType Barometer
local dev_wind = 284 				-- or nil /  dummy receive wind measures (Vent+Temp+Ressentie) / Type Wind

-- to choose between custom and %. With custom you could choose the icon!
local dev_cloudCoverPerCent = nil 	-- or nil / dummy receive cloudCover / SubType Percentage            -- to choose between custom and %
local dev_cloudCover = 295 			-- or nil / dummy receive cloudCover / SubType Custom Sensor with unit = %  -- With custom you could choose the icon!
local dev_uvIndex = 286 			-- or nil / dummy receive uvIndex / Type UV
local dev_visibility = 287 			-- or nil / dummy receive visibility / SubType Visibility
local dev_ozone = 301 				-- or nil / dummy receive ozone / SubType Custom Sensor
local dev_moonphase = {}			-- max 8 devices, no more data than 8 days
dev_moonphase[1]= 336				-- or nil / dummy receive moon phase string & icon / SubType Custom Sensor     			
dev_moonphase[2]= 337				-- or nil / dummy receive moon phase string & icon / SubType Custom Sensor     			
dev_moonphase[3]= 338				-- or nil / dummy receive moon phase string & icon / SubType Custom Sensor     			
dev_moonphase[4]= 339				-- or nil / dummy receive moon phase string & icon / SubType Custom Sensor     			
dev_moonphase[5]= nil				-- or nil / dummy receive moon phase string & icon / SubType Custom Sensor     			
dev_moonphase[6]= nil				-- or nil / dummy receive moon phase string & icon / SubType Custom Sensor     			
dev_moonphase[7]= nil				-- or nil / dummy receive moon phase string & icon / SubType Custom Sensor     			
dev_moonphase[8]= nil				-- or nil / dummy receive moon phase string & icon / SubType Custom Sensor     			

local dev_moonphase_icon = 180		-- don't change variable for icon on custom moonphase device !
local isDebug = 3					-- 0 for no debug, 1 or 2 to get informations on script

--[[
    My DarkSky secret key, the latitude and longitude of my home are contained in 3 user variables (type string)
    Ma clé secrète DarkSky, la latitude et la longitude de mon domicile sont contenus dans 3 variables utilisateurs (type chaine)
    
    local DarkSkyAPIkey = domoticz.variables('api_forecast_io').value
    local geolocalisation = domoticz.variables('Latitude').value..","..domoticz.variables('Longitude').value

    If you want to enter this information directly into the script, comment the two lines above, uncomment the following two lines
    Si vous souhaitez inscrire ces informations dans le script, commentez les deux lignes ci-dessus, décommentez les deux lignes suivantes
    
    --local DarkSkyAPIkey = "1a2bf34bf56c78901f2345f6d7890f12" --fake API number
    --local geolocalisation = "45.87,1.30" -- latitude,longitude 
    
    by personalizing them with your personal data
    finally, you can choose the level of logs, only one level can be active; comment on others in the section
    en les personnalisant avec vos données personnelles. 
    enfin vous pouvez choisir le niveau de "verbiage" des logs, seulement un niveau peut être actif; commenter les autres dans la section logging
--]]

return {
    active = true,
    on      =   {   timer           =   { 'every 4 minutes' },	-- remember only 1000 requests by day, 30mn = 48 requests
                    httpResponses   =   { "DarkSky_Trigger" }   -- Trigger the handle Json part
                },

	logging =   { -- level    	=   domoticz.LOG_INFO,        	-- Seulement un niveau peut être actif; commenter les autres
				-- level    	=   domoticz.LOG_ERROR,         -- Only one level can be active; comment others
				level    		=   domoticz.LOG_DEBUG,
				-- level    	=   domoticz.LOG_MODULE_EXEC_INFO,
				marker    		=   "Darksky Forecast v1.00 "      },

	data    =   {
		Forecast	= { initial = {} },            	-- Keep a copy of last json just in case
		lastRain	= { initial = 0 },
		lastRainExp	= { initial = 0 },
		},
	execute = function(domoticz, item)
        local DarkSkyAPIkey = domoticz.variables('api_forecast_io').value
        local geolocalisation = domoticz.variables('Latitude').value..","..domoticz.variables('Longitude').value
        --local DarkSkyAPIkey = "1a2bf34bf56c78901f2345f6d7890f12" --fake API number
        --local geolocalisation = "45.87,1.30" -- latitude,longitude 
        

        local Forecast_url  = "https://api.darksky.net/forecast/"  -- url
        local extraData = "?units=ca&exclude=flags" 

        local function debugMessage(message)
			if(isDebug>=1) then
				domoticz.log(message,domoticz.LOG_DEBUG)
			end
        end
            	
		local function THBForecast_calc(icon_val)
			local THBForecast_val = domoticz.BARO_NOINFO
			if icon_val == "" or icon_val == "wind" then
				THBForecast_val = domoticz.BARO_NOINFO
			elseif icon_val == "clear-day" or icon_val == "clear-night" then
				THBForecast_val = domoticz.BARO_SUNNY
			elseif icon_val == "partly-cloudy-day" or icon_val == "partly-cloudy-night" then
				THBForecast_val = domoticz.BARO_PARTLYCLOUDY
			elseif icon_val == "sleet" or icon_val == "fog"  or  icon_val == "cloudy" then
				THBForecast_val = domoticz.BARO_CLOUDY
			elseif icon_val == "rain" or icon == "snow" then
				THBForecast_val=domoticz.BARO_RAIN
			end
			if (isDebug > 1) then
				debugMessage('icon_val: ' .. icon_val)
				debugMessage('THBForecast_val: ' .. THBForecast_val)
			end
			return THBForecast_val
		end
		
		local function baroForecast_calc(icon_val)
			local baroForecast_val = domoticz.BARO_NOINFO
			if icon_val == "wind" then
				baroForecast_val = domoticz.BARO_UNSTABLE
			elseif icon_val == "clear-day" or icon_val == "clear-night" then
				baroForecast_val = domoticz.BARO_SUNNY
			elseif icon_val == "partly-cloudy-day" or icon_val == "partly-cloudy-night" then
				baroForecast_val = domoticz.BARO_STABLE
			elseif icon_val == "sleet" or icon_val == "fog"  or  icon_val == "cloudy" then
				baroForecast_val = domoticz.BARO_CLOUDY
			elseif icon_val == "rain" or icon == "snow" then
				baroForecast_val=domoticz.BARO_UNSTABLE
			end
			if isDebug >= 1 then
				debugMessage('icon_val: ' .. icon_val)
				debugMessage('baroForecast_val: ' .. baroForecast_val)
			end
			return baroForecast_val
		end
		
		local function humidity_status(humidity_val) -- humidity in %
			local status = domoticz.HUM_NORMAL
			if humidity_val > 69 then
				status = domoticz.HUM_WET
			elseif humidity_val < 30 then
				status = domoticz.HUM_DRY
			elseif humidity_val < 45 then
				status = domoticz.HUM_NORMAL
			else
				status = domoticz.HUM_COMFORTABLE
			end
			return status
		end
		
		local function windDirection_calc(windBearing_val) -- Wind direction calculation
			if (windBearing_val < 11.25) then
				wind_direction_val = 'N'
			elseif (windBearing_val >= 11.25 and windBearing_val < 33.75) then
				wind_direction_val = 'NNE'
			elseif (windBearing_val >= 33.75 and windBearing_val < 56.25) then
				wind_direction_val = 'NE'
			elseif (windBearing_val >= 56.25 and windBearing_val < 78.75) then
				wind_direction_val = 'ENE'
			elseif (windBearing_val >= 78.75 and windBearing_val < 101.25) then
				wind_direction_val = 'E'
			elseif (windBearing_val >= 101.25 and windBearing_val < 123.75) then
				wind_direction_val = 'ESE'
			elseif (windBearing_val >= 123.75 and windBearing_val < 146.25) then
				wind_direction_val = 'SE'
			elseif (windBearing_val >= 146.25 and windBearing_val < 168.75) then
				wind_direction_val = 'SSE'
			elseif (windBearing_val >= 168.75 and windBearing_val < 191.25) then
				wind_direction_val = 'S'
			elseif (windBearing_val >= 191.25 and windBearing_val < 213.75) then
				wind_direction_val = 'SSW'
			elseif (windBearing_val >= 213.75 and windBearing_val < 236.25) then
				wind_direction_val = 'SW'
			elseif (windBearing_val >= 236.25 and windBearing_val < 258.75) then
				wind_direction_val = 'WSW'
			elseif (windBearing_val >= 258.75 and windBearing_val < 281.25) then
				wind_direction_val = 'W'
			elseif (windBearing_val >= 281.25 and windBearing_val < 303.75) then
				wind_direction_val = 'WNW'
			elseif (windBearing_val >= 303.75 and windBearing_val < 326.25) then
				wind_direction_val = 'NW'
			elseif (windBearing_val >= 326.25 and windBearing_val < 348.75) then
				wind_direction_val = 'NNW'
			else
				wind_direction_val = 'N'
			end
			return wind_direction_val
		end
		
		-- NOTE: With this function we put readable string for moon phases values
		--       and the icon related to the moon  phase.
		--		 Darksky return a fractionnal value of moon phases
		--       The moonphases are divided in 4 new moon = 0 or 1,
		--									     1st quater = from 0.12 to 0.24,
		--									     full moon = from 0.5  to 0.62,
		--									     last quater = from 0.75 to 0.87.
		--		 We provide intermediaries phases between theses range,
		--                                       1st crescent from 0.1 to 0.11,
		--										 Maxing gibbous from 0.26 to 0.49
		--										 Maning gibbous from 0.63 to 0.74
		--										 Maning crescent from 0.88 to 0.99
		--		 The internal numbers of custom icons start at 101, so it's needed to
		--		 count icons since 101 to xxx to get the good values.
		--		 Don't put that outside of this function, except if you test if dev_moonphase isn't nil before !
		local function moonPhase_calc(moonPhase_val)
			local moon_phase_val = "Nouvelle lune"
			if(moonPhase_val > 0.0 and moonPhase_val < 0.13) then
				moon_phase_val = "Premier croissant"
				dev_moonphase_icon = 181
			elseif(moonPhase_val > 0.12 and moonPhase_val < 0.25) then
				moon_phase_val = "Premier quartier"
				dev_moonphase_icon = 182
			elseif(moonPhase_val > 0.24 and moonPhase_val < 0.5) then
				moon_phase_val = "Gibbeuse croissante"
				dev_moonphase_icon = 183
			elseif(moonPhase_val > 0.49 and moonPhase_val < 0.63) then
				moon_phase_val = "Pleine lune"
				dev_moonphase_icon = 184
			elseif(moonPhase_val > 0.62 and moonPhase_val < 0.75) then
				moon_phase_val = "Gibbeuse décroissante"
				dev_moonphase_icon = 185
			elseif(moonPhase_val > 0.74 and moonPhase_val < 0.88) then
				moon_phase_val = "Dernier quartier"
				dev_moonphase_icon = 186
			elseif(moonPhase_val > 0.87 and moonPhase_val < 1.00) then
				moon_phase_val = "Dernier croissant"
				dev_moonphase_icon = 187
			else
				moon_phase_val = "Nouvelle lune"
				dev_moonphase_icon = 180
			end
			return moon_phase_val
		end

		local function sleep(n)
		  os.execute("sleep " .. tonumber(n))
		end
		

		if (item.isTimer) then
            domoticz.openURL({
                url = Forecast_url..DarkSkyAPIkey.."/"..geolocalisation..extraData,
                callback = 'DarkSky_Trigger'
            })

        end

        if (item.isHTTPResponse and item.ok) then
            -- we know it is json but dzVents cannot detect this, so convert to Lua table
            local json = domoticz.utils.fromJSON(item.data)
            -- json is now a Lua table
            if #item.data > 0 then
                domoticz.log("All is good from DarkSky, response is ok and data are provided in Lua readable format !",domoticz.LOG_FORCE)
                domoticz.data.Forecast    = domoticz.utils.fromJSON(item.data)
                rt = domoticz.utils.fromJSON(item.data)
            else
                domoticz.log("Problem with response from DarkSky (no data) using data from earlier run",domoticz.LOG_ERROR)
                rt  = domoticz.data.Forecast                        	-- json empty. Get last valid from domoticz.data
                if #rt < 1 then                                         -- No valid data in domoticz.data either
                    domoticz.log("No previous data. are the DarkSkyAPIkey and geolocalisation ok?",domoticz.LOG_ERROR)
                    return false
                end
            end
			if (isDebug >= 1 )then
				debugMessage("heure systeme")
				debugMessage(os.date('%Y-%m-%d %H:%M:%S', time))
			end
						
			local dztemperature = domoticz.utils.round(json.currently.temperature,1)
			local dz_humidity = json.currently.humidity*100
			local hum_status = humidity_status(dz_humidity)
			local dz_pressure
			if json.currently.pressure ~= nil then
				dz_pressure = domoticz.utils.round(json.currently.pressure,0)
			end
    		local dz_THBForecast = THBForecast_calc(json.currently.icon)
			local dz_windBearing = json.currently.windBearing
    		local wind_direction = windDirection_calc(dz_windBearing)
			local dz_windSpeed_kmh = domoticz.utils.round(json.currently.windSpeed,1)		--in km/h because units = ca
    		local dz_windGust_kmh = domoticz.utils.round(json.currently.windGust,1)		--in km/h because units = ca
    		local tempChill = domoticz.utils.round(json.currently.apparentTemperature,1)
			local dz_rain
			local dz_rainExp
			local Time = require('Time')
			local now = Time()
			local nowSecondsSinceMidnight =  now.secondsSinceMidnight
			if ((json.currently.precipIntensity ~= nil) and (json.currently.precipIntensity >= 0)) then
				local lastRainUpdateInSec = domoticz.devices(dev_rain).lastUpdate.secondsAgo
				local lastRainExpUpdateInSec = domoticz.devices(dev_rainExp).lastUpdate.secondsAgo
				-- rain sensor is the total rain of the day
				-- precipIntensity is for 1 hour, so 3600 seconds, for the last update I took the part for the elapsed time)
				if lastRainUpdateInSec <= nowSecondsSinceMidnight then -- the last update was yesterday
					domoticz.data.lastRain = domoticz.data.lastRain + json.currently.precipIntensity / 3600 * lastRainUpdateInSec
				else
					domoticz.data.lastRain = json.currently.precipIntensity / 3600 * lastRainUpdateInSec
				end
				dz_rain = domoticz.utils.round(domoticz.data.lastRain, 1)
				if ((json.currently.precipProbability ~= nil) and (json.currently.precipProbability >=0)) then
					if lastRainExpUpdateInSec <= nowSecondsSinceMidnight then -- the last update was yesterday
						domoticz.data.lastRainExp = domoticz.data.lastRainExp + json.currently.precipIntensity / 3600 * lastRainExpUpdateInSec * json.currently.precipProbability
					else
						domoticz.data.lastRainExp = json.currently.precipIntensity / 3600 * lastRainExpUpdateInSec * json.currently.precipProbability
					end
					dz_rainExp = domoticz.utils.round(domoticz.data.lastRainExp, 1)
				end
				if isDebug == 2 then
					debugMessage('secondes depuis Minuit: ' .. nowSecondsSinceMidnight)
					debugMessage('rain last update: ' .. lastRainUpdateInSec)
					debugMessage("precipIntensity: " .. json.currently.precipIntensity)
					debugMessage('precipProbability: ' .. json.currently.precipProbability)
					debugMessage("lastRain: " .. domoticz.data.lastRain)
					debugMessage('dz_rain: ' .. dz_rain)
					debugMessage("lastRainExp: " .. domoticz.data.lastRainExp)
					debugMessage('dz_rainExp: ' .. dz_rainExp)
				end
				dz_rainRate = domoticz.utils.round(json.currently.precipIntensity * 100,0)
			else
				domoticz.log('Error currently.precipIntensity ' .. json.currently.precipIntensity, domoticz.LOG_ERROR)
			end
            
            local now = tonumber(os.time(os.date("*t")))
			-- Update devices for probability of rain
			-- extract them from hourly -> 48 hours, 1 to 48
			-- We can use any of data who are returned in hourly, for more informations take a look at :
			-- /home/pi/dzVents/data/__data_darksky_weather_All_no_flags.lua
            j = 1
            for i = 1,48 do
				if now > tonumber(json.hourly.data[j].time) then 
					local h = domoticz.utils.round((now - tonumber(json.hourly.data[i].time)) / 3600,0)
					j = j+h
					if (isDebug >= 1 and isDebug <=2) then
						debugMessage("j : "..j)
					end
				end 
                 
				if (proba_pluie_h[i]~=nil) then
					if (isDebug >= 1 and isDebug <=2) then
						debugMessage("heure "..i)
						debugMessage(os.date('%Y-%m-%d %H:%M:%S', json.hourly.data[i].time))
						debugMessage("probabilité de pluie: "..json.hourly.data[i].precipProbability)
					end
					domoticz.devices(proba_pluie_h[i]).updateCustomSensor(json.hourly.data[i].precipProbability*100)
				end
				if (j == 48) then
					break
				end    
				j = j +1       
            end    
			-- Update devices for daily values
			-- extract them from daily -> 8 days returned
            j = 1
            for i = 1,8 do
				-- Note: more safe to put a condition to test if there are values for each daily
				--       data in JSON file before use them !!
				-- Otherwise, script can return errors and stop the script, it's really sensitive on daily.
				if( json.daily.data[i].moonPhase~=nil) then
				-- if( json.daily.data[i].dewPoint~=nil and
					-- json.daily.data[i].windSpeed~=nil and
					-- json.daily.data[i].uvIndex~=nil and
					-- json.daily.data[i].moonPhase~=nil) then
					if (isDebug >= 1 and isDebug <=2) then
						debugMessage("jour "..i)
						debugMessage(os.date('%Y-%m-%d %H:%M:%S', json.daily.data[i].time))
						debugMessage("Quelques exemples de ce que vous pouvez exploiter dans les \'daily\'")
						debugMessage("Point de rosée "..json.daily.data[i].dewPoint)
						debugMessage("Vitesse du vent "..json.daily.data[i].windSpeed)
						debugMessage("Index UV "..json.daily.data[i].uvIndex)
					end
					-- etc., etc., to see what you have for each day you can take a look at :
					-- 	/home/pi/dzVents/data/__data_darksky_weather_All_no_flags.lua
					-- Note: if you use winSCP to edit this file, give rights to pi user the 1st time by these commands
					-- sudo chgrp pi __data_darksky_weather_All_no_flags.lua
					-- &
					-- sudo chown pi __data_darksky_weather_All_no_flags.lua
					-- for that the file is owned by pi and in pi group.
					-- Because 1st time it's owned and in group 'root' and yu'll get an error to open it
					------------------------------------------------------------------------------------
					-- your code here to update other devices
					-- Note: it could be more safe to put a condition to test if devices are declared and not nil
					-- Otherwise, script could return errors and stop itself.
					--ie:	if(temp_max_daily[i]~=nil and json.daily.data[i].temperatureHigh~=nil) then
					-- 			domoticz.devices(temp_max_daily[i]).updateTemperature(json.daily.data[i].temperatureHigh)
					--		end
					-- Here an example to change icon for the moon phase
					if(dev_moonphase[i]~=nil) then
						local dzmoonPhase
						local myDevice = domoticz.devices(dev_moonphase[i])
						dzmoonPhase = moonPhase_calc(json.daily.data[i].moonPhase)
						domoticz.devices(myDevice.idx).updateCustomSensor(dzmoonPhase)	-- -> ne fonctionne pas !!!
						if (isDebug == 3) then
							debugMessage("Nom du device "..myDevice.name)
							debugMessage("Id du device "..myDevice.idx)
							debugMessage("Phase de la lune à "..(i-1).." jour(s), valeur calculée "..dzmoonPhase)
							debugMessage("Icone de la phase = ".. dev_moonphase_icon)
						end
						domoticz.devices(myDevice.idx).setIcon(dev_moonphase_icon) 			-- -> Fonctionne mais pas d'update de la phase de lune 'texte'
						-- Provoque une erreur
						-- domoticz.openURL('http://192.168.1.12:7080/json.htm?type=setused&idx='..myDevice.idx..'&name='..myDevice.name..'&description=&switchtype=0&customimage='..dev_moonphase_icon..'&devoptions=1;'..dzmoonPhase..'&used=true')
					end
				end
                if j == 8 then
					break
				end    
                j = j +1 
            end
			-- Examples for current forecast on several devices, see more on :
			-- https://www.domoticz.com/wiki/DzVents:_next_generation_LUA_scripting#Device_object_API
			if (dev_cloudCover~=nil and json.currently.cloudCover~=nil) then
				domoticz.devices(dev_cloudCover).updateCustomSensor(json.currently.cloudCover)
				if (isDebug >= 1 and isDebug <=2) then
					debugMessage("Couverture nuageuse "..json.currently.cloudCover.."%")
				end
			end
			if(dev_temp_hum_baro~=nil) then
			    domoticz.devices(dev_temp_hum_baro).updateTempHumBaro(dz_temperature,dz_humidity,hum_status,dz_pressure,dz_THBForecast)
			end
			if (dev_barometer ~= nil) then
				domoticz.devices(dev_barometer).updateBarometer(dz_pressure, dz_baroForecast)
			end
			if(dev_temperature~=nil) then
				domoticz.devices(dev_temperature).updateTemperature(dz_temperature)
			end
			if(dev_rain~=nil) then
    			domoticz.devices(dev_rain).updateRain(dz_rainRate,dz_rain)
			end
			if(dev_rainExp~=nil) then
				domoticz.devices(dev_rainExp).updateRain(dz_rainRate,dz_rainExp)
			end
			if (dev_humidity~=nil) then
				domoticz.devices(dev_humidity).updateHumidity(dz_humidity, hum_status)
			end
			if(dev_wind~=nil) then
    			domoticz.devices(dev_wind).updateWind(dz_windBearing, wind_direction, dz_windSpeed_kmh, dz_windGust_kmh, dz_temperature,tempChill)
			end
			if(dev_cloudCover~=nil) then 
				domoticz.devices(dev_cloudCover).updateCustomSensor(json.currently.cloudCover*100)
			end
			if(dev_cloudCoverPerCent~=nil) then 
				domoticz.devices(dev_cloudCoverPerCent).updatePercentage(json.currently.cloudCover*100)
			end
			if(dev_uvIndex~=nil) then
    			domoticz.devices(dev_uvIndex).updateUV(json.currently.uvIndex)
			end
			if(dev_visibility~=nil) then
    			domoticz.devices(dev_visibility).updateVisibility(json.currently .visibility)
			end
			if (dev_ozone~=nil and json.currently.ozone ~= nil) then
				domoticz.devices(dev_ozone).updateCustomSensor(json.currently.ozone)
				if (isDebug >= 1 and isDebug <=2) then
					debugMessage("Ozone "..json.currently.ozone)
				end
			end
		end
    end   
}
